<?php

/**
 * Regular expressions helper
 *
 * @package 	PG_Core
 * @subpackage 	Helpers
 *
 * @category	helpers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!function_exists('get_numeric_reg_exps')) {

    /**
     * Get regular expression for numeric data
     *
     * @return array
     */
    function get_numeric_reg_exps()
    {
        $CI = &get_instance();

        $CI->config->load('reg_exps');
        $regs = $CI->config->item('reg_exps');

        $numeric_field_types = array('float', 'int');

        $numeric_regs = array();
        foreach ($regs as $id => $settings) {
            if (in_array($settings['field_type'], $numeric_field_types)) {
                $numeric_regs[$id] = $settings;
            }
        }

        return $numeric_regs;
    }
}
