<?php

if (!function_exists('date_picker')) {

    function date_picker(array $params = [])
    {
        $ci = get_instance();
        $default_settings = [
            'startDate' => null,
            'endDate' => null,
            'minDate' => null,
            'maxDate' => null,
            'singleDatePicker' => true,
            'timePicker' => false,
            'input_name' => 'period',
            'default_field_format' => '%d %B %Y',
        ];

        $default_data_format = 'YYYY-MM-DD'; // input format data
        $default_view_data_format = 'DD MMMM YYYY';
        $days_of_week = ld('week_day_short', 'start')['option'];

        // Sunday first
        array_unshift($days_of_week, array_pop($days_of_week));
        $monthNames = ld('month_full', 'start')['option'];
        ksort($monthNames);
        
        $locale = [
            'format' => $default_data_format,
            'formatView' => $default_view_data_format,
            'separator' => ' – ',
            'applyLabel' => l('btn_apply', 'start'),
            'cancelLabel' => l('btn_cancel', 'start'),
            'fromLabel' => l('text_from', 'start'),
            'toLabel' => l('text_to', 'start'),
            'customRangeLabel' => 'Custom',
            'daysOfWeek' => $days_of_week,
            'monthNames' => array_values($monthNames),
            'firstDay' => 1,
        ];

        $ci->load->model('Currencies_model');
        $ci->view->assign('cur_currency', $ci->Currencies_model->get_currency_default());

        if(isset($params['narrowBlock'])){
            $ci->view->assign('narrowBlock', $params['narrowBlock']);  
        }
        if(isset($params['setSpecialPrice'])){
            $ci->view->assign('setSpecialPrice', $params['setSpecialPrice']);  
        }
        if (isset($params['showPricesBlock'])) {
            $ci->view->assign('showPricesBlock', $params['showPricesBlock']);
        }
        if (isset($_SESSION['cur_listing']) && !empty($_SESSION['cur_listing'])) {
            $ci->view->assign('listingData',  $_SESSION['cur_listing']); 
        }
        $ci->view->assign('includePeriods', $params['includePeriods']);
        $ci->view->assign('getSpecialPrice', $params['getSpecialPrice']);
        $ci->view->assign('singleDatePicker', $params['singleDatePicker']);
        
        $settings = array_merge($default_settings, $params);
        $ci->view->assign('date_range', [
            'settings' => $settings,
            'locale' => $locale,
        ]);
        return $ci->view->fetch('date_range');
    }

}