<?php

namespace Pg\Libraries\Analytics\Integrations;

class Mixpanel
{
    public $ci;
    
    private $host = 'http://api.mixpanel.com/';
    private $method;
    private $name = 'Mixpanel';
    private $token = '9415f776275e03f6493761c42cd08294';
    
    
    public function __construct() {
        $this->ci = &get_instance(); 
    }
    
    public function track($event)
    {
        $this->method = 'track';
        $this->sendEvent($event);
    }

    public function sendEvent($event)
    {
        $event_data = array(
            'event' => $event,
            'properties' => array(
                'distinct_id' => $this->ci->analytics->identify_id,
                'token' => $this->token,
                'ip' => $this->ci->input->server('REMOTE_ADDR'),
                'time' => time(),
                '$device' => $this->ci->agent->platform,
                '$browser' => $this->ci->agent->browser,
                '$browser_version' => $this->ci->agent->version,
            )

        );
        $data['data'] = base64_encode(json_encode($event_data));
        $fields = $this->createUrl($data);
        $this->sendRequest($fields);
    }
    
    public function getApiKey()
    {
        return $this->token;
    }
    
    private function createUrl($data = array())
    {
        $str = '';
        foreach($data as $key => $val) {
           if(!$str) {
               $prefix = '';
           } else {
               $prefix = '&';
           }
           
           $str .= $prefix . $key . '=' . urlencode($val);
        }
        
        return $str;
    }
    
    private function sendRequest($data = array())
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_URL, $this->host . $this->method);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_exec($ch);
    }
}