<?php

namespace Pg\Modules\Country_identification\Models;

/**
 * Country_identification module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!defined('BASEPATH')) {
    exit('No direct script access allowed');
}

/**
 * Base model
 *
 * @package 	PG_RealEstate
 * @subpackage 	Country_identification
 *
 * @category	models
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
class Country_identification_model extends \Model
{
    /**
     * Module GUID
     *
     * @var string
     */
    const MODULE_GID = 'country_identification';

    /**
     * Link to CodeIgniter object
     *
     * @var object
     */
    protected $ci;

    /**
     * Settings for formatting language identification object
     *
     * @var array
     */
    protected $format_settings = array(
        'automatic_identification' => true,
    );

    /**
     * Class constructor
     *
     * @return Country_identification_model
     */
    public function __construct()
    {
        parent::__construct();
        $this->ci = &get_instance();
    }

    /**
     * Change settings for formatting language identification object
     *
     * @param string $name  parameter name
     * @param mixed  $value parameter value
     *
     * @return void
     */
    public function setFormatSettings($name, $value = false)
    {
        if (!is_array($name)) {
            $name = array($name => $value);
        }
        foreach ($name as $key => $item) {
            $this->format_settings[$key] = $item;
        }
    }

    public function setLocation($city_id, $region_id, $country_id)
    {
        $this->ci->session->set_userdata(array(
            'id_city' => $city_id, 
            'id_country' => $country_id, 
            'id_region' => $region_id, 
            'guest_no_change_location' => '1', 
        ));
        $this->load->helper('cookie');
        set_cookie('id_city', $city_id, '0');
        set_cookie('id_country', $country_id, '0');
        set_cookie('id_region', $region_id, '0');
        set_cookie('user_no_change_location', '1', '0');
    }

    public function getLocation()
    {
        $this->load->helper('cookie');
        return array(
            'id_country' => get_cookie('id_country'),
            'id_region' => get_cookie('id_region'),
            'id_city' => get_cookie('id_city'),
        );
    }

}
