<?php

/**
 * Languages module
 *
 * @package     PG_RealEstate
 *
 * @copyright   Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author      Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!defined("BASEPATH")) {
    exit("No direct script access allowed");
}

/**
 * Languages management
 *
 * @package PG_RealEstate
 * @subpackage Languages
 *
 * @category    helpers
 *
 * @copyright   Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author      Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!function_exists("lang_select")) {
    /**
     * Choise langauge block
     *
     * @return string
     */
    function lang_select()
    {
        $ci = &get_instance();
        
        $count_active = 0;
        foreach ($ci->pg_language->languages as $language) {
            if ($language["status"]) {
                ++$count_active;
            }
        }
        
        $ci->view->assign("count_active", $count_active);
        $ci->view->assign("current_lang", $ci->pg_language->current_lang_id);
        $ci->view->assign("languages", $ci->pg_language->languages);

        return $ci->view->fetch("helper_lang_select", null, "languages");
    }
}

if (!function_exists("lang_editor")) {
    /**
     * Langauge editor block
     *
     * @return string
     */
    function lang_editor()
    {
        if (INSTALL_DONE && $_ENV['ADD_LANG_MODE']) {
            $ci = &get_instance();
            $lang_editor = $ci->system_messages->get_data("lang-editor");
            $ci->view->assign("lang_editor", $lang_editor);

            return $ci->view->fetch("lang_editor", null, "languages");
        } else {
            return "";
        }
    }
}
