<?php

/**
 * News module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!defined('BASEPATH')) {
    exit('No direct script access allowed');
}

/**
 * News management
 *
 * @package 	PG_RealEstate
 * @subpackage 	News
 *
 * @category	helpers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
if (!function_exists('news_last_added')) {
    /**
     * Last added news block
     *
     * @param integer $count max news count
     * @param integer $width block width
     *
     * @return string
     */
    function news_last_added($count, $width = 100)
    {
        $ci = &get_instance();
        $ci->load->model('News_model');

        if (func_num_args() == 1 && is_array($count)) {
            $params = $count;
            $count = isset($params['count']) ? $params['count'] : 8;
            $width = isset($params['width']) ? $params['width'] : 100;
        }

        $count = intval($count);
        if (!$count) {
            $count = 8;
        }

        $attrs['where']['status'] = 1;
        $news = $ci->News_model->get_news_list(1, $count, array("id" => "DESC"), $attrs);

        if (empty($news)) {
            return '';
        }

        $ci->view->assign("news", $news);

        $ci->view->assign("block_width", $width);

        return $ci->view->fetch("helper_latest_added_news", "user", "news");
    }
}
