function loadingContent(optionArr){
	var randNumber = Math.round(Math.random(1000)*1000);
	this.properties = {
		loadBlockID: 'user_load_content'+randNumber,
		loadBlockBgID: 'user_load_content_bg'+randNumber,
		loadBlockBgClass: 'load_content_bg noPrint',
		linkerObjID: '',
		loadBlockLeftType: 'center',
		loadBlockLeftPoint: 0,
		loadBlockTopType: 'center',	
		loadBlockTopPoint: 0,
		dir: site_rtl_settings, 	
		posPropertyLeft: "left",
		posPropertyRight: "right",
		blockBody: false,
		modalClass: 'pg_modal',
		destroyOnClose: false,
		modalContentClass: 'modal-content',
		modalBodyClass: 'modal-body',
		modalIdBody: 'modal-body' + randNumber,
		customClass: null,
		loadBlockContentInnerClass: 'load_content_inner col-md-6 col-md-offset-3 col-sm-8 col-sm-offset-2',
		loadBlockContentInnerID: 'inner_'+randNumber,																	
		loadBlockContentInner3Class: 'load_content_inner',
		loadBlockContentInner3ID: 'inner3_'+randNumber,		
		headerBlockClass: 'lc-header',
		headerBlockID: 'header'+randNumber,
		loadBlockContentInner2Class: 'load_content_inner2',
		loadBlockContentInner2ID: 'inner2_'+randNumber,
		loadBlockContentOuterClass: 'lc-content-outer',
		loadBlockContentOuterID: 'outer'+randNumber,
		closeBtnClass: 'load_content_close',
		iBtnClass: 'fa fa-close',
		removeOnClose: false,
		closeBtnID: 'user_load_content_close'+randNumber,
		closeBtnUse: true,
		closeBtnPadding: 5,
		closeMessageBtn: 'btn_close_message',
		draggable: false,
		showAfterImagesLoad: true,
		contentImages: 0,
		contentLoadedImages: 0,
		leftBtnID:  'user_load_content_left'+randNumber,
		leftBtnClass: 'load_content_left',
		leftBtnFunction: function(){},
		leftBtnCreated: false,
		rightBtnID:  'user_load_content_right'+randNumber,
		rightBtnClass: 'load_content_right',
		rightBtnFunction: function(){},
		rightBtnCreated: false,
		onClose: function(){},
		
		destroyOnReload: true
	}

	var _self = this;

	this.Init = function(options){
		_self.properties = $.extend(_self.properties, options);
		_self.create_load_block();
		$(document).on('pjax:start', function(e){
			if(_self.properties.destroyOnReload){
				_self.destroy();
			}else{
				_self.hide_load_block();
			}
		});
	}

	this.removeOnClose = function(){
		_self.properties.removeOnClose = true;
	}

	this.extend_errors = function(errors){
		_self.errors = $.extend(_self.errors, errors);
	}

	this.removeBlock = function(){
		$("body")
			.find('#'+_self.properties.loadBlockID+', #'+_self.properties.loadBlockBgID+', #'+_self.properties.closeBtnID+', #'+_self.properties.leftBtnID+', #'+_self.properties.rightBtnID)
			.remove();
	}
	
	this.destroy = function(){
		_self.hide_load_block();
		_self.removeBlock();
	}

	this.create_load_block = function(){
		$("body").append('<div id="'+_self.properties.loadBlockBgID+'" class="noPrint"></div>');

		if(_self.properties.linkerObjID){
			$("#"+_self.properties.loadBlockBgID).after('<div id="'+_self.properties.loadBlockID+'"></div>');			
		}else{
			$("#"+_self.properties.loadBlockBgID).append('<div id="'+_self.properties.loadBlockID+'"></div>');
		}
		$("#"+_self.properties.loadBlockBgID).addClass(_self.properties.loadBlockBgClass)
		if(_self.properties.draggable){
			$("#"+_self.properties.loadBlockID).draggable({ handle: "h1" });
		}

		$("#"+_self.properties.loadBlockID).append('<div id="'+_self.properties.headerBlockID+'"></div>');
		$("#"+_self.properties.loadBlockID).addClass(_self.properties.loadBlockContentInnerClass);
		$("#"+_self.properties.headerBlockID).addClass(_self.properties.headerBlockClass);
		$("#"+_self.properties.loadBlockID).append('<div id="'+_self.properties.loadBlockID+'_content"></div>');
		$("#"+_self.properties.loadBlockID+'_content').append('<div class="'+_self.properties.modalContentClass+'">'
																+'<div id="'+_self.properties.modalIdBody+'" class="'+_self.properties.modalBodyClass+'">'
																+'</div>'
																+'</div>');
		if (_self.properties.closeBtnUse) {
			_self.create_close();
		}
	}

	this.setCustomClass = function(new_class){
		_self.properties.customClass = new_class;
	}

	this.show_load_block = function(content, animate){
		if (_self.properties.customClass && $("#"+_self.properties.loadBlockID).hasClass(_self.properties.loadBlockContentInnerClass)) {
			$("#"+_self.properties.loadBlockID).removeClass(_self.properties.loadBlockContentInnerClass);
			$("#"+_self.properties.loadBlockID).addClass(_self.properties.customClass);
		}
		$('html').css('overflow', 'hidden');
		animate = animate || false;
		_self.active_bg();
		var height_old = $("#"+_self.properties.loadBlockID+'_content').height();
		$("#"+_self.properties.modalIdBody).html(content);
		var height = $("#"+_self.properties.loadBlockID+'_content').height();
		if(animate && height_old && height){
			$("#"+_self.properties.loadBlockID+'_content').stop().css('height', height_old + 'px').animate({'height': height+'px'}, 100, function(){$(this).css('height', 'auto')});
		}
		if(_self.properties.showAfterImagesLoad){
			_self.properties.contentImages = $("#"+_self.properties.loadBlockID + ' img').length;
			_self.properties.contentLoadedImages = 0;
			_self.show_after_load();
		}else{
			$("#"+_self.properties.loadBlockID).fadeIn();
			if(_self.properties.closeBtnUse){
				_self.active_close();	
			}
			if(_self.properties.leftBtnCreated){
				_self.active_left();	
			}
			if(_self.properties.rightBtnCreated){
				_self.active_right();	
			}
		}
		if(_self.properties.blockBody){
			var window_width = $(window).width();
			$('body').css('overflow', 'hidden');
			var margin = ($(window).width() - window_width);
			$('body').css('margin-'+_self.properties.posPropertyRight, margin + 'px');
			
			$('#'+_self.properties.loadBlockBgID).css({'overflow-x': 'auto', 'overflow-y': 'scroll', 'display': 'block'});			
		}
		$('#' + _self.properties.closeMessageBtn).click(function(){
			_self.destroy();
		});
	}
	
	this.show_after_load = function(){
		//$("body").css({'overflow': 'hidden'});
		$("#"+_self.properties.loadBlockBgID).css({'overflow': 'auto'});
		if(_self.properties.contentLoadedImages < _self.properties.contentImages){
			$("#"+_self.properties.loadBlockID + ' img').load(function(){	
				_self.properties.contentLoadedImages++;
			});
			$("#"+_self.properties.loadBlockID + ' img').error(function(){	
				_self.properties.contentLoadedImages++;
			});
			setTimeout( _self.show_after_load, 300);
		}else{
			$("#"+_self.properties.loadBlockID).fadeIn();
			if(_self.properties.closeBtnUse){
				_self.active_close();	
			}
			if(_self.properties.leftBtnCreated){
				_self.active_left();	
			}
			if(_self.properties.rightBtnCreated){
				_self.active_right();	
			}
		}
	}

	this.hide_load_block = function(){
		$('html').css('overflow', '');

		if(window.wc_videoStreamUrl){
			window.wc_videoStreamUrl = null;
		}
		if(_self.properties.blockBody){
			$('body').css('overflow', 'auto').css('margin-'+_self.properties.posPropertyRight, 'auto');
		}

		$("#"+_self.properties.loadBlockBgID).hide();

		if($("#"+_self.properties.loadBlockID).css('display') == 'none'){
			return;
		}
		_self.clear_buttons();

		$("#"+_self.properties.loadBlockID).fadeOut(300, function(){
			$("#"+_self.properties.modalIdBody).html('');
			_self.inactive_bg();
		});

		$("body").css({'overflow': 'visible'});
		$("#"+_self.properties.loadBlockBgID).css({'overflow': 'hidden'});

		_self.properties.onClose();

		if (_self.properties.removeOnClose) {
			_self.removeBlock();
		}
 	}
	
	this.clear_buttons = function(){
		if(_self.properties.closeBtnUse){
			_self.inactive_close();		
		}
		if(_self.properties.leftBtnCreated){
			_self.inactive_left();	
		}
		if(_self.properties.rightBtnCreated){
			_self.inactive_right();	
		}	
	}

	this.active_bg = function(){
		$("#"+_self.properties.loadBlockBgID).fadeIn(100).unbind().bind('click', function(e){
			if($(e.target).attr('id') == _self.properties.loadBlockBgID){
				if(_self.properties.destroyOnClose) {
					_self.destroy();	
				} else {
					_self.hide_load_block();
				}
			}
		});
	}

	this.inactive_bg = function(){
		if($("#"+_self.properties.loadBlockBgID).css('display') != 'none'){
			$("#"+_self.properties.loadBlockBgID).fadeOut();		
			$("#"+_self.properties.loadBlockBgID).unbind();
		}
	}
	
	this.active_close = function(){
		$("#"+_self.properties.closeBtnID).bind('click', function(){
			if(_self.properties.destroyOnClose) {
				_self.destroy();	
			} else {
				_self.hide_load_block();
			}
		});
		$("#"+_self.properties.closeBtnID).fadeIn();
	}
	
	this.inactive_close = function(){
		if($("#"+_self.properties.closeBtnID).css('display') != 'none'){
			$("#"+_self.properties.closeBtnID).unbind();
			$("#"+_self.properties.closeBtnID).fadeOut();
		}
	}
	
	this.create_close = function(){
		$("#"+_self.properties.headerBlockID).append('<div id="'+_self.properties.closeBtnID+'"></div>');
		$("#"+_self.properties.closeBtnID).addClass(_self.properties.closeBtnClass);
		$("#"+_self.properties.closeBtnID).append('<i class="'+_self.properties.iBtnClass+'"></i>');
	}
	

	this.create_left = function(func){
		_self.inactive_left();
		$("#"+_self.properties.loadBlockID).append('<div id="'+_self.properties.leftBtnID+'"></div>');
		_self.properties.leftBtnFunction = func;
		_self.properties.leftBtnCreated = true;
		$("#"+_self.properties.leftBtnID)
			.addClass(_self.properties.leftBtnClass)
			.css({
				'cursor': 'pointer',
				'position': 'absolute',
				'display': 'none',
				'z-index': '1001'
			});
		_self.position_left();		
	}

	this.create_right = function(func){
		_self.inactive_right();
		$("#"+_self.properties.loadBlockID).append('<div id="'+_self.properties.rightBtnID+'"></div>');
		_self.properties.rightBtnFunction = func;
		_self.properties.rightBtnCreated = true;
		$("#"+_self.properties.rightBtnID)
			.addClass(_self.properties.rightBtnClass)
			.css({
				'cursor': 'pointer',
				'position': 'absolute',
				'display': 'none',
				'z-index': '1001'
			});
		_self.position_right();		
	}	
	
	this.active_left = function(){
		_self.position_left();
		$("#"+_self.properties.leftBtnID).unbind('click').bind('click', _self.properties.leftBtnFunction).fadeIn();
	}
	
	this.inactive_left = function(){
		$("#"+_self.properties.leftBtnID).remove();
		_self.properties.leftBtnCreated = false;
	}
	
	this.active_right = function(){
		_self.position_right();
		$("#"+_self.properties.rightBtnID).unbind('click').bind('click', _self.properties.rightBtnFunction).fadeIn();
	}
	
	this.inactive_right = function(){
		$("#"+_self.properties.rightBtnID).remove();
		_self.properties.rightBtnCreated = false;
	}

    this.setOptions = function (options) {
        return this;
    }
    
    this.changeTemplate = function(template) {
        return this;
    }
	
	_self.Init(optionArr);
	return _self;
};
