<?php
/**
 * Test class for phpMorphy_UserDict_Pattern.
 * Generated by PHPUnit on 2010-11-30 at 05:22:33.
 */
class phpMorphy_UserDict_PatternTest extends PHPUnit_Framework_TestCase
{
    /**
     * @var phpMorphy_UserDict_Pattern
     */
    protected $object;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp()
    {
        $this->object = new phpMorphy_UserDict_Pattern(
            'test',
            new phpMorphy_UserDict_GrammarIdentifier(
                'pos',
                array('a', 'b')
            )
        );
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown()
    {
    }

    public function testConstructFromString()
    {
        // word + part of speech + grammems
        $this->assertEquals(
            $this->object,
            phpMorphy_UserDict_Pattern::constructFromString("   test \t\t\t \t pos a   , b")
        );

        // only word
        $this->assertEquals(
            new phpMorphy_UserDict_Pattern('test', new phpMorphy_UserDict_GrammarIdentifier(null, array())),
            phpMorphy_UserDict_Pattern::constructFromString("   test \t\t\t    ")
        );
    }

    public function testMatchWord()
    {
        $this->assertTrue($this->object->matchWord('test'));
    }

    /**
     * @todo Implement testMatch().
     */
    public function testMatch()
    {
        $this->assertTrue(
            $this->object->match(
                'test',
                'pos',
                array('a', 'c', 'b')
            )
        );
    }
}
?>
